#!/bin/bash

execute()
{
    local outdir="output"
    local topdir="$(pwd)"
    local tstamp="$(printf "%x" $(date +%s))"

    set -exu

    rm -rf "$outdir"
    mkdir "$outdir"

    rsync -av "template/" "$outdir" || return 1
    rsync -av --exclude "template" --exclude "$outdir" --exclude ".git" "./" "$outdir/provisioning" || return 1

    pushd "$outdir" || return 1

    chown -R 499:499 .
    chown -R 0:0 etc/sudoers.d/

    tar --transform='s#^[.]/##' --show-stored-names -zcvf "$topdir/ooredoo-sbc-provisioning-template-v2314-v1-E1-$tstamp.tgz" "."

    popd
}

if [ "w$1" = "was-root" ]
then
    execute
else
    sudo bash "$0" "as-root" "$@"
fi

